import { world, system, ItemStack } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
export function getScore(objective, target, useZero = false) {
  try {
    const score = world.scoreboard.getObjective(objective)
    if (typeof target == 'string') return score.getScore(score.getParticipants().find(part => part.displayName == target))
    return score.getScore(target.scoreboardIdentity);
  } catch {
    return useZero ? 0 : NaN
  }
}
world.afterEvents.entityHitEntity.subscribe(data => {

})
world.afterEvents.entityHurt.subscribe(data => {
  let hh = data.hurtEntity.getComponent("health")
  if (data.hurtEntity.hasTag("fami") == true) {
    let entity = data.hurtEntity;
    const hh = entity.getComponent("health");
    if (hh.currentValue < 1) {
      let chance = Math.floor(Math.random() * 20)
      if (chance == 1) {
        chance = 0;

        let stack = new ItemStack("blayy:magic_weapon_bag", 1)
        entity.dimension.spawnItem(stack, entity.location);
      }
    }
  } 
  try {
    if (data.damageSource.damagingEntity.getComponent("inventory").container.getItem(data.damageSource.damagingEntity.selectedSlot).typeId.startsWith("blayy:diazed_blade")) {
      let player = data.damageSource.damagingEntity;

      player.runCommandAsync('scoreboard objectives add dhit dummy');
      let dhits = getScore("dhit", player)
      player.runCommandAsync('scoreboard players add @s dhit 1');
      player.runCommandAsync(`title @s title .                        x${dhits}   .`);
      data.hurtEntity.runCommandAsync(`damage @s ${dhits} fire`)
      let d = Math.round(data.damage)
      player.runCommandAsync(`title @s subtitle §c-${d} ; ${Math.round(hh.currentValue)}/${hh.defaultValue}                           §6ExtraDamage`);
      player.addTag("dhit")
    }
  } catch (error) {

  }
  try {
    if (data.damageSource.damagingEntity.getComponent("inventory").container.getItem(data.damageSource.damagingEntity.selectedSlot).typeId.startsWith("blayy:calamity_scythe")) {
      let player = data.damageSource.damagingEntity

      player.runCommandAsync('scoreboard objectives add chit dummy');
      let chits = getScore("chit", player)
      player.runCommandAsync('scoreboard players add @s chit 1');

      player.runCommandAsync(`title @s title .                        x${chits}   .`);
      data.hurtEntity.runCommandAsync(`effect @s weakness 2 ${chits}`)
      let d = Math.round(data.damage)
      player.runCommandAsync(`title @s subtitle §c-${d} ; ${Math.round(hh.currentValue)}/${hh.defaultValue}                           §5Weakness`);
      player.addTag("chit")

    }
  } catch (error) {

  }
  try {
    if (data.damageSource.damagingEntity.getComponent("inventory").container.getItem(data.damageSource.damagingEntity.selectedSlot).typeId.startsWith("blayy:divine_stone_hammer")) {
      let player = data.damageSource.damagingEntity

      player.runCommandAsync('scoreboard objectives add dshit dummy');
      let dshits = getScore("dshit", player)
      player.runCommandAsync('scoreboard players add @s dshit 1');

      player.runCommandAsync(`title @s title .                        x${dshits}   .`);
      data.hurtEntity.runCommandAsync(`effect @s slowness 1 ${dshits}`)
      let d = Math.round(data.damage)
      player.runCommandAsync(`title @s subtitle §c-${d} ; ${Math.round(hh.currentValue)}/${hh.defaultValue}                           §8Stunning`);
      player.addTag("dshit")

    }
  } catch (error) {

  }
  try {
    if (data.damageSource.damagingEntity.getComponent("inventory").container.getItem(data.damageSource.damagingEntity.selectedSlot).typeId.startsWith("blayy:blooming_spear")) {
      let player = data.damageSource.damagingEntity

      player.runCommandAsync('scoreboard objectives add bhit dummy');
      let bhits = getScore("bhit", player)
      player.runCommandAsync('scoreboard players add @s bhit 1');

      player.runCommandAsync(`title @s title .                        x${bhits}   .`);
      player.runCommandAsync(`effect @s health_boost 4 ${bhits}`)
      let d = Math.round(data.damage)
      player.runCommandAsync(`title @s subtitle §c-${d} ; ${Math.round(hh.currentValue)}/${hh.defaultValue}                           §dHealth`);
      player.addTag("bhit")

    }
  } catch (error) {

  }
  
});
system.runInterval(r => {
  world.getDimension("overworld").runCommandAsync('scoreboard players set @a[tag=!dhit] dhit 1');
  world.getDimension("overworld").runCommandAsync(`title @a[tag=dhit] title '                                           '`);  
  world.getDimension("overworld").runCommandAsync(`tag @a[tag=dhit] remove dhit`);  
  world.getDimension("overworld").runCommandAsync('scoreboard players set @a[scores={dhit=10..}] dhit 0');

  world.getDimension("overworld").runCommandAsync('scoreboard players set @a[tag=!chit] chit 1');
  world.getDimension("overworld").runCommandAsync(`title @a[tag=chit] title '                                           '`);
  world.getDimension("overworld").runCommandAsync(`tag @a[tag=chit] remove chit`);
  world.getDimension("overworld").runCommandAsync('scoreboard players set @a[scores={chit=10..}] chit 0');

  world.getDimension("overworld").runCommandAsync('scoreboard players set @a[tag=!dshit] dshit 1');
  world.getDimension("overworld").runCommandAsync(`title @a[tag=dshit] title '                                           '`);
  world.getDimension("overworld").runCommandAsync(`tag @a[tag=dshit] remove dshit`);
  world.getDimension("overworld").runCommandAsync('scoreboard players set @a[scores={dshit=10..}] dshit 0');

  world.getDimension("overworld").runCommandAsync('scoreboard players set @a[tag=!bhit] bhit 1');
  world.getDimension("overworld").runCommandAsync(`title @a[tag=bhit] title '                                           '`);
  world.getDimension("overworld").runCommandAsync(`tag @a[tag=bhit] remove bhit`);
  world.getDimension("overworld").runCommandAsync('scoreboard players set @a[scores={bhit=10..}] bhit 0');

  

 

}, 40)
world.afterEvents.itemUse.subscribe(b => {
 if (b.itemStack.typeId == "blayy:diazed_pattern") {
   const desp = new ActionFormData();
desp.title("§e§l - DIAZED PATTERN -")
let blaze_powder = 0;
let diamond = 0;
let glowstone_dust = 0;
let magma_cream = 0;

for (let i = 0; i < 35; i++) {
  const item = b.source.getComponent("inventory").container.getItem(i);
  if (item) {
    if (item.typeId == "minecraft:blaze_powder") {
    blaze_powder += item.amount;
  }
  if (item.typeId == "minecraft:diamond") {
    diamond += item.amount;
  }
  if (item.typeId == "minecraft:glowstone_dust") {
    glowstone_dust += item.amount;
  }
  if (item.typeId == "minecraft:magma_cream") {
    magma_cream += item.amount;
  }
  }
  
};
desp.body({ rawtext: [ { translate: "item.blaze_powder.name" }, { text: ` §6${blaze_powder}/64\n§f` }, { translate: "item.diamond.name" }, { text: ` §6${diamond}/32\n§f` }, { translate: "item.glowstone_dust.name" }, { text: ` §6${glowstone_dust}/64\n§f` }, { translate: "item.magma_cream.name" }, { text: ` §6${magma_cream}/16§f` } ] } )

desp.button( { translate: "text.despertar" } )
desp.show(b.source).then(r => {
  if (r.selection == 0) {
if (blaze_powder >= 64 && diamond >= 32 && glowstone_dust >= 64 && magma_cream >= 16) {
  b.source.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"Sucess!!"}]}`)
  b.source.runCommandAsync(`clear @s blaze_powder 0 64`)
  b.source.runCommandAsync("clear @s diamond 0 32")
  b.source.runCommandAsync("clear @s glowstone_dust 0 64")
  b.source.runCommandAsync("clear @s magma_cream 0 16")
  b.source.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 blayy:diazed_blade_1")
}
}
}) 
 }
 if (b.itemStack.typeId == "blayy:divine_stone_pattern") {
   const desp = new ActionFormData();
desp.title("§6§l - DIVINE STONE PATTERN -")
let blackstone = 0;
let obsidian = 0;
let gold_block = 0;
let emerald_block = 0;

for (let i = 0; i < 35; i++) {
  const item = b.source.getComponent("inventory").container.getItem(i);
  if (item) {
    if (item.typeId == "minecraft:blackstone") {
    blackstone += item.amount;
  }
  if (item.typeId == "minecraft:obsidian") {
    obsidian += item.amount;
  }
  if (item.typeId == "minecraft:gold_block") {
    gold_block += item.amount;
  }
  if (item.typeId == "minecraft:emerald_block") {
    emerald_block += item.amount;
  }
  }
  
};
desp.body({ rawtext: [ { translate: "tile.blackstone.name" }, { text: ` §8${blackstone}/64\n§f` }, { translate: "tile.obsidian.name" }, { text: ` §8${obsidian}/64\n§f` }, { translate: "tile.gold_block.name" }, { text: ` §8${gold_block}/16\n§f` }, { translate: "tile.emerald_block.name" }, { text: ` §8${emerald_block}/9§f` } ] } )

desp.button( { translate: "text.despertar" } )
desp.show(b.source).then(r => {
  if (r.selection == 0) {
if (blackstone >= 64 && obsidian >= 64 && gold_block >= 16 && emerald_block >= 9) {
  b.source.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"Sucess!!"}]}`)
  b.source.runCommandAsync(`clear @s blackstone 0 64`)
  b.source.runCommandAsync("clear @s obsidian 0 64")
  b.source.runCommandAsync("clear @s gold_block 0 16")
  b.source.runCommandAsync("clear @s emerald_block 0 9")
  b.source.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 blayy:divine_stone_hammer_1")
}
}
}) 

 } 
 if (b.itemStack.typeId == "blayy:calamity_pattern") {
   const desp = new ActionFormData();
desp.title("§5§l - CALAMITY SCYTHE PATTERN -")
let redstone_block = 0;
let fermented_spider_eye = 0;
let nether_wart = 0;
let ghast_tear = 0;

for (let i = 0; i < 35; i++) {
  const item = b.source.getComponent("inventory").container.getItem(i);
  if (item) {
    if (item.typeId == "minecraft:redstone_block") {
    redstone_block += item.amount;
  }
  if (item.typeId == "minecraft:fermented_spider_eye") {
    fermented_spider_eye += item.amount;
  }
  if (item.typeId == "minecraft:nether_wart") {
    nether_wart += item.amount;
  }
  if (item.typeId == "minecraft:ghast_tear") {
    ghast_tear += item.amount;
  }
  }
  
};
desp.body({ rawtext: [ { translate: "tile.redstone_block.name" }, { text: ` §c${redstone_block}/18\n§f` }, { translate: "item.fermented_spider_eye.name" }, { text: ` §c${fermented_spider_eye}/64\n§f` }, { translate: "item.nether_wart.name" }, { text: ` §c${nether_wart}/64\n§f` }, { translate: "item.ghast_tear.name" }, { text: ` §c${ghast_tear}/16§f` } ] } )

desp.button( { translate: "text.despertar" } )
desp.show(b.source).then(r => {
  if (r.selection == 0) {
if (redstone_block >= 18 && fermented_spider_eye >= 64 && nether_wart >= 64 && ghast_tear >= 16) {
  b.source.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"Sucess!!"}]}`)
  b.source.runCommandAsync(`clear @s redstone_block 0 18`)
  b.source.runCommandAsync("clear @s fermented_spider_eye 0 64")
  b.source.runCommandAsync("clear @s nether_wart 0 64")
  b.source.runCommandAsync("clear @s ghast_tear 0 16")
  b.source.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 blayy:calamity_scythe_1")
}
}
}) 

 } 
 if (b.itemStack.typeId == "blayy:blooming_pattern") {
   const desp = new ActionFormData();
desp.title("§2§l - BLOOMING PATTERN -")
let moss_block = 0;
let cherry_sapling = 0;
let glistering_melon_slice = 0;
let oak_log = 0;

for (let i = 0; i < 35; i++) {
  const item = b.source.getComponent("inventory").container.getItem(i);
  if (item) {
    if (item.typeId == "minecraft:moss_block") {
    moss_block += item.amount;
  }
  if (item.typeId == "minecraft:cherry_sapling") {
    cherry_sapling += item.amount;
  }
  if (item.typeId == "minecraft:glistering_melon_slice") {
    glistering_melon_slice += item.amount;
  }
  if (item.typeId == "minecraft:oak_log") {
    oak_log += item.amount;
  }
  }
  
};
desp.body({ rawtext: [ { translate: "tile.moss_block.name" }, { text: ` §d${moss_block}/64\n§f` }, { translate: "tile.cherry_sapling.name" }, { text: ` §d${cherry_sapling}/64\n§f` }, { translate: "item.speckled_melon.name" }, { text: ` §d${glistering_melon_slice}/64\n§f` }, { translate: "tile.wood.oak.name" }, { text: ` §d${oak_log}/16§f` } ] } )

desp.button( { translate: "text.despertar" } )

  desp.show(b.source).then(r => {
    if (r.selection == 0) {
if (moss_block >= 64 && cherry_sapling >= 64 && glistering_melon_slice >= 64 && oak_log >= 64) {
  b.source.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"Sucess!!"}]}`)
  b.source.runCommandAsync(`clear @s moss_block 0 64`)
  b.source.runCommandAsync("clear @s cherry_sapling 0 64")
  b.source.runCommandAsync("clear @s glistering_melon_slice 0 64")
  b.source.runCommandAsync("clear @s oak_log 0 64")
  b.source.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 blayy:blooming_spear_1")
}
}
}) 



 } 
})